(*

ZMFCHANG.PAS
(C)opyright 1999 by Brian Zhou.  All rights reserved.

FILENAME  : ZMFCHANG.PAS

PURPOSE   : To go through Mystic's MYSTIC.DAT and LANUGAGE.DAT to modify
            the paths.  This is particularly useful if you move your BBS
            setup from drive to drive often.

DISCLAIMER: This software comes with no guarantee/warantee.  If this screws
            up your computer somehow, it's your own fault.

Do not redistrubute this with your name on it.  If you have made modifications
to this code, send them to me.

- zoob@telebot.net

*)

Program zMFChange;

{$P+}
Uses Crt,DOS;
{$I MREC_105.PAS}

Var
  Cfg : ConfigRec;
  CfgF: File of ConfigRec;
  Lng : LangRec;
  LngF: File Of LangRec;
  C   : Char;

Procedure varChange(Var S : String);
Begin
    WriteLn(S);
    C := Readkey;
    S[1] := C;
    GotoXY(1, WhereY);
    WriteLn(S);
End;

Begin
  Writeln('ZMChangePath v0.12');
  writeln('(C)opyright 1999 by Brian Zhou.  All rights reserved.');
  writeln;
  Assign(CfgF, 'mystic.dat');
  {$I-} Reset(CfgF); {$I+}
  If IOResult <> 0 Then Begin
    Writeln('MYSTIC.DAT not found!');
    Halt;
  End;
  Read(CfgF,Cfg);
  WriteLn('Modifying MYSTIC.DAT paths');
  Writeln;
  With Cfg Do Begin
    varChange(SysPath);
    varChange(AttachPath);
    varChange(DataPath);
    varChange(MsgsPath);
    varChange(ProtPath);
    varChange(ArcsPath);
    varChange(QwkPath);
    varChange(ScriptPath);
    varChange(LogsPath);
  End;
  Close(CfgF);
  Rewrite(CfgF);
  Write(CfgF, Cfg);
  Close(CfgF);

  WriteLn;
  Writeln;
  writeln('Modifying LANGUAGE.DAT');
  writeln;
  Assign(LngF, Cfg.DataPath+'language.dat');
  {$I-} Reset(LngF); {$I+}
  If IOResult <> 0 Then Begin
    Writeln(Cfg.DataPath+'LANGUAGE.DAT not found!');
    Halt;
  End;
  Repeat
    Read(LngF, Lng);
    varChange(Lng.TextPath);
    varChange(Lng.MenuPath);
    Seek(LngF, FilePos(LngF)-1);
    Write(LngF, Lng);
  Until Eof(LngF);
  Close(LngF);
End.
